VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmClient 
   Caption         =   "CornflakeZone Chat Client"
   ClientHeight    =   4350
   ClientLeft      =   2340
   ClientTop       =   2985
   ClientWidth     =   4320
   LinkTopic       =   "Form1"
   ScaleHeight     =   4350
   ScaleWidth      =   4320
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   495
      Left            =   1560
      TabIndex        =   6
      Top             =   3720
      Width           =   1215
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   495
      Left            =   2880
      TabIndex        =   5
      Top             =   3720
      Width           =   1335
   End
   Begin MSWinsockLib.Winsock sktClient 
      Left            =   360
      Top             =   600
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.TextBox txtInput 
      Height          =   855
      Left            =   120
      TabIndex        =   1
      Top             =   2760
      Width           =   4095
   End
   Begin VB.TextBox txtOutput 
      Height          =   2055
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   360
      Width           =   4095
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "Send"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   3720
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   "Session"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Input"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   2520
      Width           =   1575
   End
End
Attribute VB_Name = "frmClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim myName As String

Private Sub AddToOutput(myText As String)
    
    txtOutput.Text = myText & vbNewLine & txtOutput.Text
   
End Sub

Private Sub cmdClose_Click()
    ' close the connection
    If sktClient.State <> sckClosed Then sktClient.Close
    Unload Me
End Sub

Private Sub cmdConnect_Click()

    ' First close the socket
    sktClient.Close
    
    ' Tell the user what's going on
    Call AddToOutput(vbNewLine & "Connecting on " & _
        gIPAddress & ", port " & gPort & vbNewLine)

    ' Connect to the server
    sktClient.Connect
    
    ' Reset my handle
    myName = "unknown"
End Sub

Private Sub cmdSend_Click()

    ' Set the name of the client
    If myName = "unknown" Then
        
        ' we know the user's been asked to enter their
        ' handle by the server, they'll type it into txtInput
        myName = txtInput.Text
        
        ' Reset my title bar
        Me.Caption = "CornflakeZone.com Chat - " & myName
        
    End If
    
    ' Send the data
    sktClient.SendData txtInput.Text
    
    ' Zero the input
    txtInput.Text = ""
    
End Sub

Private Sub Form_Load()

    ' Initiate the connection to the server
    sktClient.RemoteHost = gIPAddress
    sktClient.RemotePort = gPort
    
    Call AddToOutput(vbNewLine & "Connecting on " & gIPAddress & ", port " & gPort & vbNewLine)
    
    ' Connect to the server
    sktClient.Connect
    
    ' Reset my handle
    myName = "unknown"
    
End Sub

Private Sub sktClient_DataArrival(ByVal bytesTotal As Long)
    
    Dim newdata As String
    
    ' Get the arriving data and print it out.
    sktClient.GetData newdata
    
    ' add the data to the output
    txtOutput.Text = newdata & txtOutput.Text
    
End Sub

Private Sub sktClient_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    ' This should handle any winsock errors.
    Call AddToOutput("Error: " & Description)
End Sub
