******************************************************************************
* Aplicativo para liberar catraca
******************************************************************************
*  Estado das Saidas:
*  ------------------
*  SAI(11,.T.) Habilita giro sentido horario da catraca
*  SAI(12,.F.) Liga lampada vermelha
*  SAI(12,.T.) Liga Lampada verde
*  SAI(13,.T.) Habilita giro sentido anti-horario da catraca
*  As saidas 11 e 13 so' podem ser setadas para T individualmente.
*  Caso mais de um seja setada, a prioridade e' a seguinte: 13 e 11
*
*  Estado das Entradas:
*  --------------------
*  ENT(21) T somente ao final do giro, no sentido horario, permanecendo
*            neste estado ate' que SAI(11,.F.) 
*  ENT(22) T somente ao final do giro, no sentido anti-horario, permanecendo
*            neste estado ate' que SAI(13,.F.) 
*  ENT(23) T sempre que a catraca estiver em situacao de repouso
*
*****************************************************************************
**        Exemplo de uso da DLL: CA100
*****************************************************************************
* As instrucoes FREAD e FWRITE sao utilizadas para intercambio dos          *
* dados entre as catracas(ou microterminais) e a aplicacao                  *
* desenvolvida em VB ou Delphi                                              *
* Os parametros: handle do arquivo, numero de bytes a ser escrito e         *
* numero de bytes a ser lido destas funcoes sao desconsiderados             *
*****************************************************************************
*****************************************************************************

SET SERIAL TO CLP
BATLOW
engana_comp=.F.

IF engana_comp=.T.
	reset=.F.
ENDIF

i = 0
i1 = 0
i2 = 0
t = .t.
z1 = 0
lmaximo = 0
aux = space(250)
aux1 = space(250)

@ 01,01 SAY "PASSO AUTOMACAO "

for i1 = 1 to 50
   IF I1 < 16
      @ 02,I1 SAY "."
   ENDIF
  
   I = INKEY()
   if i = 8 
      exit 
   endif 
next

IF I = 8
   i1 = 0
   @ 01,01 SAY " DIGITE A SENHA "
   @ 02,01 SAY " ==============="
  	CLEAR TYPEAHEAD 
  	@ 3,1 get I1
   
ENDIF

IF I1 = 984367
  	BATLOW
  	*
  	* Colocar a senha  neste local
  	*
 	* Configura para reset geral
  	i=1
  	i1=1
  	WRITERAM(i,i1)
	carga
ENDIF

* Verifica se deve inicializar os dados da ram e ramdrive
i  = 1
I1 = READRAM(I)
IF I1 = 1
   RESET = .F.
else
   reset = .t.
ENDIF 

IF reset=.T.
	@ 01,01 say "P001 Versao 3.1  "
	@ 02,01 SAY "PASSO AUTOMACAO  "
	do delay
	do delay    
    
ELSE     
   @ 01,01 say "P001 Versao 3.1   "
  	@ 02,01 SAY " INICIALIZANDO    "   
   
   *1-lmaximo número maximo de cartoes,2-Ultimo Movimento Offline,3-Dia da ultima atualizacao
   ramdrive varmax(3,4)     
   *Movimento Off line cartao         
   ramdrive marsai(2200,14) 
   *Movimento Off Line função,refeição,dia,hora
   ramdrive marsaic(2200,14)  && FRDDMMAAHHMM
   varmax[1] = "0"
   varmax[2] = "0"     
   reset = .t.  
	* Informa que os dados foram inicializados com sucesso
  	i=1
 	i1=0
   WRITERAM(i,i1)   
   for i = 1 to 2
      marsai[i] = "0"
      marsaic[i] = "0"
   next
   
endif 


handle = 0
nrobytes = 0
inicad = .f.
aux = space(250)
nBip = 0
nBip = 2
n2 = 0
i = 0
hh = 0
E01 = .F.
E02 = .F.
E03 = .F.
sCr2 = " "
scr3 = " "
ierro = 0
rel1 = space(12)
rel2 = space(12)
dia = space(10)
sCr2 = chr(2)
scr3 = chr(1)
bEmp = .f.
kdata = 0
flag = .F.
t  = .T.
rt = 0
IHORA = 0
sPonto = "X1"
lin1 = SPACE(16)
lin2 = SPACE(16)
xEnt = " "
sEnv = space(2)
cartp = space(14)
sterm = space(6)
sterm = terminal()
aux = space(16)
sOpcio = "0"
sAlmoc = "0"
online=0
offline=0
data=RAMDATE()
aux = "CO" 
dado = aux + sterm
aux = "LIGAFOUND"
ligafound=space(20)
ligafound=dado+aux

*********************************************************************

for i = 1 to 2200
   aux = marsai[i] 
	if aux = "0" 
      i = i -1 
      exit 
   endif      
next

if i > 2099 
   i = 2099
endif 

aux = strzero(i,4,0) 
varmax[2] = aux 




@ 01,01 say "P001 Versao 3.1"
@ 02,01 SAY "PASSO AUTOMACAO"
do delay 
do delay

DO CONFIGREL

cartao = SPACE(16)
DO WHILE t =.T.
	SET CURSOR ON
	SET KEY -1 TO FUN_PONT1
	SET KEY -3 TO FUN_PONT3
	SET KEY t(99) TO Atualiza
	sOpcio = "1" 
	sAlmoc = "0"
   cartao = space(16)
   original = space(16)
   do Atu_DATA  
   CLEAR TYPEAHEAD
	@ 2,01 SAY  "APROXIME  CARTAO  "
   do testecom
   SET PONTO ON
   @ 3,2 GET cartao
   SET PONTO OFF
	IF cartao=""
		LOOP
	ENDIF
	online=0
   *
   * TESTAR TECLADO
   *
   sString = " "
   sString  = substr(cartao,1,1)
   
   if sstring = "X" .or.  sString = "Y"
      loop
   endif

   aux = alltrim(cartao) 
   cartao = aux 
   i= len(cartao)

   if i  < 9
      loop
   endif 
 
   IF I = 12 .or. i = 14
      xEnt = "E"
   else
      xEnt=SUBSTR(cartao,i,1)
   endif 
   IF I >= 14
      cartao = substr(cartao,1,14)     
   ELSE
      IF I >= 12
         cartao = substr(cartao,1,12)
      ELSE
         cartao = substr(cartao,1,10)
      ENDIF 
   ENDIF  

   i = val(cartao) 
   cartao = strzero(i,14,0)  


   flag= FOUND() 
   original = substr(cartao,1,14) 
   if flag = .f.
   	cartao = original
      do GRAVAOFF
      if i1 = 1 
            libera = "A"
            nBip = 1
        	   do bip_bip
         	DO LIBPORTA
      endif 
      LOOP  
   ENDIF  
        
   
   if xEnt <>  "E" .and. xEnt <> "D" .and. xEnt <> " "
      xEnt = " "
   endif

   if xEnt = "D"
      xEnt = "S"
   endif


   IF cartao = "            "
      LOOP
   ENDIF

   *do EnvOff
 
   sPonto  = "P1"
   flag = .f.
   sEnv = "PP"

   DO ENVDADOS
  	DO RECRESP

   flag=FOUND()
   if flag = .f. 	
      cartao = original
      i1 = 1 
      do GRAVAOFF
      if i1 = 1 
         libera = "A"
         nBip = 1
    	   do bip_bip
       	DO LIBPORTA
      endif 
      LOOP  
   ENDIF  

   sEnv = "HV"
   DO ENVDADOS

ENDDO
QUIT

*********************************************************************
PROCEDURE RECRESP
*********************************************************************
blidos = 0
resposta = space(250)         && Variavel para receber os dados
libera = ""
lin1 = space(16)
lin2 = space(16)
lin3 = space(16)
lin4 = space(16)
lin5 = space(32)
lin6 = space(6)
sSenha = space(6)

@ 1,1 SAY " Favor Esperar  "
@ 2,1 SAY "   Resposta...  "

do respost

IF blidos > 0
   DO limpa

   libera = SUBSTR(resposta,66,1)
   lin1 =   SUBSTR(resposta,2,16)
   lin2 =   SUBSTR(resposta,18,16)
   lin3 =   substr(resposta,34,16)
   lin4 =   substr(resposta,50,16)
   lin5 =   lin3 + lin4
   lin6 =   substr(resposta,67,6)
   libera = substr(resposta,1,1)   
   aux = alltrim(lin1) 
   bemp = empty(aux) 
   if bemp = .t.
      libera = "B"
      lin1 =  "NAO FOI RECEBIDA"
      lin2 =  "   RESPOSTA!    "
   endif 
     
   
   if libera = "X"
      libera = "B"
      for n2 = 1 to 3
         @ 1,1 SAY " Digite a Senha   "
         @ 2,1 say ">                 "

         *
         * Limpa buffer do teclado
         *
         Set cursor ON
         CLEAR TYPEAHEAD
         DO PEGA_SENHA
        

         if sSenha = lin6
            libera = substr(resposta,1,1)
            n2 = 4
         else
            nBip = 2
            do bip_bip
            @ 1,1 say " Senha Invalida "
            @ 2,1 say "                "
            sSenha = "      "
            DO DELAY
            do delay
            do delay

 
         endif
      next
   endif 

   if libera = "U" 
      libera = "S"
   endif 


   if libera  <> "E" .and. libera <> "S"      
      libera = "B"
   endif   
           

   do limpa   
       
   if libera = "B"
      nBip = 2
      do bip_bip
      @ 1,1 say lin1
      @ 2,1 say lin2
      DO DELAY
      DO DELAY
     
   else
      if empty(lin5) = .f.
        	@ 1,1 SAY "                 "
        	@ 2,1 SAY "                 "
        	@ 1,1 say lin3
        	@ 2,1 say lin4
        	nBip = 2
        	do bip_bip
        	do delay
        	do delay
      else
        	nBip = 1
        	do bip_bip
      endif
      DO LIBPORTA
      

   ENDIF

ELSE
   * @ 1,1 SAY "NAO FOI RECEBIDA"
   * @ 2,1 SAY "   RESPOSTA!    "
   * DO delay
   *DO delay
   *Verifica cadastro off line 
ENDIF

RETURN

*********************************************************************
PROCEDURE ENVDADOS
*********************************************************************
dado = space(50)
dado = sEnv + sterm
dado = dado + sPonto
dado = dado + sOpcio
dado = dado + cartao
dado = dado + xEnt
dado = dado + salmoc
dado = dado + "1"
do envia

return
*********************************************************************
procedure envia 
*********************************************************************
flag = .F.
SET PONTO ON
FWRITE(handle, dado, 0)
flag = neterr()
SET PONTO OFF 

RETURN
*********************************************************************
PROCEDURE DELAY
*********************************************************************
FOR i=0 to 30
NEXT
RETURN

*********************************************************************
PROCEDURE DELAY2
*********************************************************************
FOR i=0 to 5
NEXT
RETURN
*********************************************************************
PROCEDURE LIMPA
*********************************************************************
@ 1,1 SAY "                "
@ 2,1 SAY "                "
RETURN
********************************************************************
PROCEDURE LIBPORTA
********************************************************************
** Espera 3 segundo
rt = 0
E01 = .f.
E02 = .f.
DO LIMPA
do case
case libera = "A"
   @ 1,1 SAY "  PONTO ACEITO  "
   rt = 1 
case libera = "E"
   @ 1,1 SAY "  PONTO ACEITO  "
   rt = 1
case libera = "S"
   @ 1,1 SAY "  PONTO ACEITO  "
   rt = 2
CASE LIBERA = " "
   @ 1,1 SAY "  PONTO ACEITO  "
   rt = 1 
endcase

i = val(salmoc)
@ 2,1 say "================"
IF sopcio="1"
	if i > 0 .AND. I < 4
	   @ 2,1 SAY "RESEVADO  ALMOCO" 
	ENDIF
ENDIF
IF sopcio="3"
	if i > 0 .AND. I < 4
	   @ 2,1 SAY " RESEVADO JANTA " 
	ENDIF
ENDIF

      
*sai(15,.T.)
*atusai()

do delay 
do delay 
do delay

*
* trava imediatamente a catraca
*
*sai(15,.F.)
*atusai()

RETURN

********************************************************************
PROCEDURE CONFIGREL
********************************************************************
n1 = 0
hora = SPACE(8)
dia  = space(10)

do Ajusta_Hora
if blidos = 1
	dia = dtoc(data)
	** ano
	rel1 = SUBSTR(dia,9,2)
	rel2 = rel1
	** mes
	rel1 = SUBSTR(dia,4,2)
	rel2 = rel2 + rel1
	** dia da semana
	rel2 = rel2 + "1"
	** dia
	rel1 = SUBSTR(dia,1,2)
	rel2 = rel2 + rel1
	** hora
	rel1 = SUBSTR(hora,1,2)
	n1 = val(rel1)
	rel1 = strzero(n1,2,0)
	rel2 = rel2 + rel1
	** minuto
	rel1 = SUBSTR(hora,4,2)
	rel2 = rel2 + rel1
	n1 = CONREL(rel2)
endif

RETURN
********************************************************************
PROCEDURE Atualiza
********************************************************************
cartao=""
RETURN

********************************************************************
PROCEDURE Atu_DATA
********************************************************************
do while t = .t.
	if kdata = 0 
   	blidos = 0 
   	do configrel
 	endif 
   kdata = kdata + 1   
	IF kdata > 50
    	kdata = 0
	ENDIF
   
   do datetime 
    
	flag = found()
    
	if flag = .t.
		DO Envoff
		* busca dia da última carga
      i= 2
      i1 = readram(i) 
		aux = substr(dia,1,2) 
		n1 = val(aux) 
		* Verifica se mudou o dia para fazer nova carga
		if n1 <> i1 .and. hh > 3
			* Se passou das 3 horas e mudou o dia, então faz a carga se não houver dados armazenados
	         aux = varmax[2] 
	         i = val(aux) 
	         if i = 0
	         	*Nao existem dados entao verifica se e´para resetar
	         	* salva controle de reset
	           	i=1
	         	i1=1
	  	         WRITERAM(i,i1)
		         aux = substr(dia,1,2) 
		         i1 = VAL(aux)
					* salva dia da atualizacao
	           	i=2
	  	         WRITERAM(i,i1)
	            carga
	         endif
		endif
	endif 
   exit
enddo
@ 1,1  SAY "                "
@ 1,1  say dia
@ 1,12 say hora  
RETURN

********************************************************************
procedure Fun_Pont1
********************************************************************
do while t = .t.
   DO DATETIME
   IF HH > 9
       @ 01,01 say "RESERVA INVALIDA"
       @ 02,01 SAY " ALMOCO APOS 9h "   
       do delay
       do delay
       do delay 
       cartao=""
       exit   
   endif 
 
	if sOpcio = "1" 
     	IF sAlmoc <> "0"
         cartao=""
         exit
      ENDIF  
	endif 

   sOpcio = "1"

	@ 01,01 say "1-PADRAO 2-SABOR"
	@ 02,01 say "3-LIGHT  4-Sair "
	i = 0
	do while i < 49
   	i = inkey(0)
   	if i > 52 
      	i = 0
   	endif 
	enddo
   n2 = inkey()
   n2 = inkey()


	DO case
	case i = 49
   	salmoc = "1"    
	case i = 50
   	salmoc = "2"
	case i = 51
   	salmoc = "3"
   CASE I = 52
      cartao=""
      exit
	endcase
   DO Atu_DATA

  	DO case
	case salmoc = "1"    
      @ 2,1 say "RES.ALMOC PADRAO" 
	case salmoc = "2"
   	@ 2,1 say "RES.ALMOC  SABOR"
	case salmoc = "3" 
      @ 2,1 say "RES.ALMOC  LIGHT"    
	endcase 

   EXIT
ENDDO
RETURN


********************************************************************
procedure respost
********************************************************************
blidos = 0
resposta = space(250)         && Variavel para receber os dados

SET PONTO ON
flag = .F.
blidos = FREAD(handle,resposta, nrobytes)
flag = neterr()
if flag = .f.
   blidos = 1
   libera = substr(resposta,1,1) 
   if libera = sCr2     
      resposta = substr(resposta,2,90)
   endif     
   if libera = sCr3     
      resposta = substr(resposta,2,90)
   endif   

   aux = substr(resposta,1,5)
	DO case
	case aux = "ZZ010"    
      *
      *Inicializa
      *  
   	t= rop()
	case aux = "ZZ111"  		
  		*
 		* Configura para reset geral
      *
      BATLOW  
  		i=1
  		i1=1
  		WRITERAM(i,i1)
		carga 
	endcase 

endif 
SET PONTO OFF
return

********************************************************************
procedure Fun_Pont3
********************************************************************
do while t = .t.
	if sOpcio = "3" 
      IF sAlmoc <> "0"
	      cartao=""
   		exit
      ENDIF  
	endif 
   sOpcio = "3"

	@ 01,01 say "1-PADRAO 2-SABOR"
	@ 02,01 say "3-LIGHT  4-Sair "

	i = 0
	do while i < 49
   	i = inkey(0)
   	if i > 52 
      	i = 0
   	endif 
	enddo

   n2 = inkey()
   n2 = inkey()
	DO case
	case i = 49
   	salmoc = "1"    
	case i = 50
   	salmoc = "2"
	case i = 51
   	salmoc = "3"
   CASE I = 52
      cartao=""
      exit 
	endcase

   DO Atu_DATA

 	DO case
	case salmoc = "1"    
      @ 2,1 say "RES.JANTA PADRAO" 
	case salmoc = "2"
   	@ 2,1 say "RES. JANTA SABOR"
	case salmoc = "3" 
      @ 2,1 say "RES. JANTA LIGHT"    
	endcase
   EXIT
ENDDO
RETURN

*********************************************************
PROCEDURE Bip_Bip
*********************************************************
j=0
FOR j=1 to 2
	TONE(1,1)
	FOR i=1 to 5
	NEXT
NEXT
RETURN

*************************************************
PROCEDURE Pega_Senha
*************************************************
a=0
num=0
sSenha = ""
string_d = ""
c1 = ""

DO WHILE num<8
   a=INKEY(0)
   IF a<48
      DO CASE
      CASE a=8
         num=LEN(chave)
         num=num-1
         IF num<0
            num=0
         ENDIF
         sSenha   = substr(sSenha, 1, num)
         string_d = substr(string_d, 1, num)
         @2,2 SAY "      "
      CASE a=13
         EXIT
      ENDCASE
   ELSE
      a=a-48
      c1=STR(a,1,0)
      sSenha=sSenha+c1
      string_d=string_d+"*"
      num=num+1
   ENDIF
   @ 2,2 SAY string_d
ENDDO
@ 2,2 SAY "      "
RETURN

*=======================================================
PROCEDURE Ajusta_Hora
*=======================================================
* Format do string data/hora  AAMMSDDHHMM
data = ramdate()
hora = ramtime()

flag= .t.
*FOUND()
blidos = 0

if flag = .t.
	sEnv = "HH"
	DO ENVDADOS
	@ 1,1 SAY "  ATUALIZANDO   "
	@ 2,1 SAY "  DATA E HORA   "
   
   do respost
   
endif 
if blidos = 1
   blidos = 0 
	libera = substr(resposta,1,1)
	if libera = "H"
   	*do limpa
   	lin1 = substr(resposta,3,16)
   	lin2 = substr(resposta,19,16)
      aux = substr(lin1,1,10)
      lin1 = substr(resposta,5,1)
      if lin1 = "/"
         lin1 = substr(resposta,8,1)
         if lin1 = "/"
         	data = ctod(aux)
  				hora = substr(lin2 ,1,8)  
         	blidos = 1
         endif 
      endif   
	endif
     
endif 


RETURN 


*=======================================================
PROCEDURE datetime
*=======================================================
hora = RAMTIME()
data = RAMDATE()
dia =  dtoc(data)
rel1 = SUBSTR(hora,1,2)
hh = val(rel1)

rel2 = SUBSTR(hora,3,2)
i= val(rel2)
 
if i > 0 
   hh = hh + 1
endif

rel1 = rel1 + ":"
rel1 = rel1 + rel2
hora = rel1 
RETURN
*=======================================
procedure GravaOff
*=======================================
do datetime
dado = sOpcio+sAlmoc
aux = substr(dia,1,2) 
dado = dado + aux
aux =substr(dia,4,2) 
dado = dado + aux
aux = substr(dia,9,2) 
dado = dado + aux
aux = substr(hora,1,2) 
dado = dado + aux
aux = substr(hora,4,2) 
dado = dado + aux

aux  = varmax[2]
i = val(aux) 
i = i+ 1

if i < 2100
   aux = strzero(i,4,0) 
   varmax[2] = aux
   aux = substr(cartao,1,14)
   marsai[i] = aux
   marsaic[i] = Dado
   i1 = 1
   i = i+ 1
	marsai[i] = "0"
	marsaic[i] = "0"
else
   @ 01,01 say " MEMORIA CHEIA   "
   @ 02,01 SAY " =============   "     
   if i > 2100
   	*
   	*Inicializa, pois o equipamento se perdeu 
   	*  
 		t= rop()
   endif   
   do delay
   do delay 
   i1 = 0  
endif 
 
return

*=======================================
procedure EnvOff
*=======================================
aux  = varmax[2]
i = val(aux) 
IF i>0
	visor=space(40)
	SAVE SCREEN TO visor
   ierro = 0
	do while i > 0 
	   @ 01,01 say " SINCRONISANDO   "
	   @ 02,01 SAY " DADOS........   "
	   aux1 = marsaic[i]  
	   aux =  marsai[i]
	   dado = space(50)
	   aux = "PP"
	   dado = aux + sterm
	   aux = "DD"                  
	   dado = dado + aux       
	   aux = substr(aux1,1,1)  
	   dado = dado + aux  
	   aux = marsai[i]         
	   dado = dado + aux
	   dado = dado + "E"     
	   aux = substr(aux1,2,1)
	   dado = dado + aux
	   dado = dado + "1"
	   aux = substr(aux1,3,10)
	   dado = dado + aux
	   do envia
	   do respost
	
	   IF blidos > 0 	
	      aux = marsai[i]
	      aux = substr(aux,1,14) 
	      lin1 =   SUBSTR(resposta,1,4)
	      lin2 =   SUBSTR(resposta,5,14)
	      if lin1 <> "OKDD"  
	         exit
	      endif 
         marsai[i] = "0"
         marsaic[i] = "0"   
	      i = i -1 
	      aux = strzero(i,4,0) 
	      varmax[2] = aux      
         ierro = 0 
	   else
         ierro = ierro + 1
         if ierro = 3
            ierro = 0 
	         exit
         endif 

	   endif 
	ENDDO
	RESTORE SCREEN FROM visor
ENDIF		 
return
*=================================
procedure testecom
 
flag=FOUND()
if flag = .f.
	online=0
	offline=offline+1
	If offline<5
	  	dado = ligafound
	  	do envia
	ELSE
		offline=0
		set device to com
		@ 1,1 SAY "UUUUUU"
		set device to screen	
    	dado = ligafound
	  	do envia
	Endif
ELSE
	*avisa servidor que está ativo
	online=online+1
	If online>3
		online=0
  	  	dado = ligafound
	  	do envia
	EndIF
endif

flag = .t.

return

